/*******************************************************************************
 * @author    Patricie Benešová
 * @version   1.00.000
 */
import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;


public class Vyhledavac
{
   private List<Zvire> seznamZvirat = new ArrayList<>();

    public Vyhledavac() {
        seznamZvirat.add(new Zvire("kočka", 4, 2, "savec"));
        seznamZvirat.add(new Zvire("pes", 4, 15, "savec"));
        seznamZvirat.add(new Zvire("kráva", 4, 1, "savec"));
        seznamZvirat.add(new Zvire("had", 0, 2, "plaz"));
        seznamZvirat.add(new Zvire("papoušek", 2, 2, "pták"));
        seznamZvirat.add(new Zvire("velryba", 0, 1, "ryba"));
        seznamZvirat.add(new Zvire("želva", 4, 5, "plaz"));
    }

    /**
     * Getter pro získání seznamu zvířat
     */
    public List<Zvire> getSeznamZvirat() {
        return seznamZvirat;
    }
    
    public static void main(String[] args) {
        
        Vyhledavac p = new Vyhledavac();
        
        //vytvoření instancí funkčního rozhraní Predicate
        Predicate<Zvire> ctyrnohySavec = x -> x.getDruh().equals("savec")  && x.getPocetNohou() == 4;
        Predicate<Zvire> jednorocniZvire = x -> x.getVek() == 1;
        Predicate<Zvire> lichyVek = x -> x.getVek() % 2 != 0;
        
              
        //vypsání seznamu nalezených zvířat
        
        System.out.println("Čtyř nohý savec:");
        p.filtrovatZvirata(p.getSeznamZvirat(), ctyrnohySavec);
        
        
        System.out.println("Jednoroční zvíře:");
        p.filtrovatZvirata(p.getSeznamZvirat(), jednorocniZvire);
        
        
        System.out.println("Zvíře s lichým věkěm:");
        p.filtrovatZvirata(p.getSeznamZvirat(), lichyVek);
                
    }
    
   /**
    * Pomocná metoda pro filtrování seznamu zvířat a vypsání výsledku do konzole
    */   
   public void filtrovatZvirata(List<Zvire> seznam, Predicate<Zvire> predikat){
       seznam.stream().filter(predikat).forEach((n) -> System.out.println(n));
   }
}
